package com.mile.v4_navigation_engine.model

import java.util.*

/**
Created by Corentin Houdayer on 2019-08-21
Dev profile https://github.com/houdayec
 **/

enum class LanguageCode {
    FR{
        override fun toString(): String {
            return "FR"
        }
    },
    EN{
        override fun toString(): String {
            return "EN"
        }
    },
    ES{
        override fun toString(): String {
            return "ES"
        }
    },
    IT{
        override fun toString(): String {
            return "IT"
        }
    },
    DE{
        override fun toString(): String {
            return "DE"
        }
    },
    PT{
        override fun toString(): String {
            return "PT"
        }
    };

    fun getLocaleLanguage() : String {
        when(this){
            FR -> return Locale("fr").language
            EN -> return Locale.ENGLISH.language
            ES -> return Locale("es").language
            DE -> return Locale("de").language
            IT -> return Locale("it").language
            PT -> return Locale("pt").language
            else -> return Locale("fr").language
        }
    }

    fun getLocale() : Locale {
        when(this){
            FR -> return Locale("fr")
            EN -> return Locale.ENGLISH
            ES -> return Locale("es")
            DE -> return Locale("de")
            IT -> return Locale("it")
            PT -> return Locale("pt")
            else -> return Locale("fr")
        }
    }

     companion object{
         fun getLanguageCodeFromLocale(locale: Locale) : LanguageCode{
             when(locale.displayLanguage.toLowerCase()){
                 "english" -> return EN
                 "français" -> return FR
                 else -> return EN
             }
         }

         fun getLanguageCodeFrom(code: String) : LanguageCode{
             when(code.toLowerCase()){
                 "en" -> return EN
                 "fr" -> return FR
                 "es" -> return ES
                 "de" -> return DE
                 "it" -> return IT
                 "pt" -> return PT
                 else -> return EN
             }
         }
     }

}